{
Ŀ
                                PCX-SHARP                                  
       ⥪  ࠡ  䠩 PCX  ணࠬ  TPascal 7.0      
                       Coded by VanDamM, 14-07-97                          
                           All right reserved                              

} {F+}
Unit P_Sharp;
Interface
Uses Graph;
Type
 Pcx_Header = Record
      manufacturer : byte; { ⥫ }
      version: byte;       {  Paintbrash }
      encoding: byte;      { ஢ }
      bits_per_pixel: byte;  { -   ᥫ }
      MinX,MinY: integer;    { ࠧ ࠦ,  孨 㣮 }
      MaxX,MaxY: integer;    { ࠧ ࠦ, ࠢ  㣮 }
      horz_res: integer;     { - ᥫ  ਧ⠫ }
      vert_res: integer;     { - ᥫ  ⨪ }
      ega_palette: array[0..47] of byte; {  }
      reserved: byte;                    {  }
      num_color_planes: byte;            {  }
      bytes_per_line: integer;           {  }
      palette_type: integer;             {  }
      padding: array[1..62] of byte;     {  }
 End;

  RGB_color_typ = record
                   red, green, blue: byte
                  end;

  FName = string[12];


Procedure ReadPCXfile( Name: FName; UX, UY : integer );

Implementation

Procedure Set_Palette_Register(index: integer; color: RGB_color_typ);
 Begin
  port[$3C6]:= $FF;
  port[$3C8]:= index;
  port[$3C9]:= color.red;
  port[$3C9]:= color.green;
  port[$3C9]:= color.blue;
 End;

Procedure ReadPCXfile( Name: FName; UX, UY : integer );
Var
    X, Y, i, k: Integer;
    Pcx_Head : Pcx_Header;
    Pcx_File : file;
    Data: byte;
    Palette: array[0..255] of RGB_color_typ;

Begin
{ 뢠 䠩 ଠ PCX }
 Assign(Pcx_File, Name);
 Reset(Pcx_File, 1);

{ ⥭  }
Seek(Pcx_File, FileSize(Pcx_File)-768);
for x:=0 to 255 do
 begin
 BlockRead(Pcx_File, Palette[x].red, 1);
  Palette[x].red:=Palette[x].red shr 2;
 BlockRead(Pcx_File, Palette[x].green, 1);
  Palette[x].green:=Palette[x].green shr 2;
 BlockRead(Pcx_File, Palette[x].blue, 1);
  Palette[x].blue:=Palette[x].blue shr 2;
 end;

{ ⠭  }
 for y:=0 to 255 do
    begin
     port[$3C6]:= $FF;
     port[$3C8]:= y;
     port[$3C9]:= Palette[y].red;
     port[$3C9]:= Palette[y].green;
     port[$3C9]:= Palette[y].blue;
    end;

{ ⥭  PCX 䠩 }
  Seek(Pcx_File, 0);
  BlockRead(Pcx_File, Pcx_Head, 128);

{ ⥭ ஢ ࠦ }
For Y:=UY to (UY+Pcx_Head.vert_res-1) do
 For X:=UX to (UX+Pcx_Head.horz_res-1) do
  begin
   BlockRead(Pcx_File, Data, 1);
   If Data>=192 then
    begin
     i:=Data-192; BlockRead(Pcx_File, Data, 1);
     For k:=1 to i do
      begin
        If X>(UX+Pcx_Head.horz_res) then begin X:=UX; Y:=Y+1; end;
        PutPixel(X,Y,Data);
        If k<i then Inc(X);
      end
    end
   else
    PutPixel(X,Y,Data);
  end;
{  }
Close(Pcx_File);
End;
End.